<?php

class user {
public
    $health     = 0,        # жизнь
    $vest       = 0,        # броник
    $gun        = array(),  # используемое оружие
    $guns       = array(),  # доступное оружие
    $bullets    = array(),  # пули
    $backpack   = array(),  # рюкзак
    $trophy     = array(),  # трофеи
    
    $login      = '',       # логин
    $name       = '',       # имя
    $mail       = '',       # e-mail
    $pass       = '',       # пароль, кодированный по base64
    $setting    = array(),  # предпочтения
    $session    = array(),  # если сессия прервалась (например, произошёл краш браузера), изменения не будут потеряны
    
    $money      = 0,        # тратинги
    $die        = 0,        # сколько раз умер
    $selfdie    = 0,        # сколько раз убил себя
    $frag       = 0,        # сколько убил
    $kill       = 0,        # сколько npc убил
    $expirience = 0,        # опыт
    $level      = 1,        # уровень
    $time       = 0,        # время последнего действия
    
    $loc        = array();  # на какой локации находится
    
private
    $_journal   = array();  # журнал сообщений
    
    function __construct() {
        $this->initialize();
    }
    
    /**
    * инициализация. происходит сброс некоторых настроек в значения по умолчанию
    */
    function initialize() {
        $this->health           = 100;
        $this->vest             = 0;
        $this->gun              = array();
        $this->guns             = array();
        $this->loc              = array();
        $this->bullets          = array();
        $this->backpack         = array();
        
        # выдаём оружие
        $this->_add_gun('gun0');           # бензопила прилагается (:
        $this->_add_gun('gun1');           # пистолет
        $this->change_gun('gun1');         # оружие по умолчанию — пистолет
        $this->_add_bullets('bullet', 20); # даём игроку 20 патронов
    }
    
    /**
    * сменить оружие
    */
    function change_gun($gun_name) {
        # если текущеу оружие уже выбрано, выход
        if ( ! empty($this->gun) && $this->gun['gun'] == $gun_name) return TRUE;
        # если запрашиваемого оружия у перса нет
        if ( ! isset($this->guns[$gun_name])) return FALSE;
        
        if ( ! empty($this->gun)) {
            # сохраняем оружие, которое находится в руках у перса
            $gun    = $this->gun;
            $type   = $gun['gun'];
            unset($gun['gun']);
        }
        
        # устанавливаем новое оружие
        $this->gun         = $this->guns[$gun_name];
        $this->gun['gun']  = $gun_name;
        
        # старое оружие также никуда не девается и доступно для выбора
        if (isset($gun)) $this->guns[$type] = $gun;
        
        # удаляем старое оружие из рюкзака
        unset($this->guns[$gun_name]);
        
        return TRUE;
    }
    
    /**
    * Проверяет, есть ли у перса требуемый ключ
    */
    function is_key($key) {
        # если пустое значение, ключ не третуется
        if ($key == '') return TRUE;
        return isset($this->backpack['keys'][$key]);
    }
    
    /**
    * пересохраняет профиль юзера
    *
    * @param bool $clear_sess очищать ли массив
    */
    function save_state($clear_sess = TRUE) {
        $this->initialize();
        if ($clear_sess) $this->session = array();
        file_put_contents(USERS . $this->login . '.dat', serialize($this));
    }
    
    /**
    * добавляет в рюкзак пользователю предмет
    */
    function add_item($item) {
        global $items, $bullets, $guns;
        $name = TRUE;
        
        # данные поступают в виде: i.stimpack, или g.gun1
        $t    = explode('.', $item);
        $type = $t[0];
        $item = $t[1];
        $cnt  = isset($t[2]) ? $t[2] : -1;
        
        switch ($type) {
        case 'i':
            if (isset($items[$item])) {
                if ($this->_add_item($item)) $name = $items[$item]['name'];
                else $name = FALSE;
            } else $name = FALSE;
            break;
        case 'g':
            if (isset($guns[$item])) { # если оружие
                if ($this->_add_gun($item, $cnt)) $name = $guns[$item]['name'];
                else $name = FALSE;
            } else $name = FALSE;
            break;
        case 'c':
            if (isset($bullets[$item])) { # если патроны
                if ($cnt > 0 && $this->_add_bullets($item, $cnt)) $name = $bullets[$item]['name'];
                else $name = FALSE;
            } else $name = FALSE;
            break;
        default: $name = FALSE;
        }
        return $name;
    }
    
    /**
    * возвращает урон для текущего оружия
    */
    function get_damage() {
        global $cfg;
        
        $bullet = $this->gun['bullet']; # используемые патроны
        
        # проверка наличия патронов (естественно, если есть расход патронов на выстрел)
        if ($this->gun['rate'] && empty($this->bullets[$bullet]['cur'])) return 1;
        
        # проверка, перезарядилось ли оружие
        if ($this->gun['recharge'] > ITIME) return 2;
        
        # если патроны не расходуются, возращаем просто урон
        if (empty($this->gun['rate'])) {
            $this->gun['recharge'] = ITIME + $this->gun['time'] * ACTIME;
            return array(
                'damage'     => $this->gun['damage'],
                'add_damage' => empty($this->gun['add_damage']) ? array() : $this->gun['add_damage'],
                'self_damage'=> empty($this->gun['self_damage']) ? 0 : 1
            );
        }
        
        $damage = $this->gun['damage'];
        
        if ($this->gun['rate'] > $this->bullets[$bullet]['cur']) {
            $rate = $this->bullets[$bullet]['cur'];
            $this->bullets[$bullet]['cur'] = 0;
            $damage[0] = intval($damage[0] / $this->gun['rate'] * $rate);
            $damage[1] = intval($damage[1] / $this->gun['rate'] * $rate);
        } else {
            $this->bullets[$bullet]['cur'] -= $this->gun['rate'];
        }
        
        return array(
            'damage'     => $damage,
            'add_damage' => empty($this->gun['add_damage']) ? array() : $this->gun['add_damage'],
            'self_damage'=> empty($this->gun['self_damage']) ? 0 : 1
        );
    }
    
    /**
    * подсчитывает повреждения
    */
    function damage($losses) {
        # сначала снимаем броник
        $this->vest -= $losses;
        # если броня стала отрицательной…
        if ($this->vest < 0) { # переносим повреждения на здоровье
            $this->health += $this->vest;
            $this->vest = 0;
            if ($this->health < 0) $this->health = 0;
        }
    }
    
    /**
    * добавляет трофей
    */
    function add_trophy($trophy) {
        if ( ! isset($this->trophy[$trophy[3]])) $this->trophy[$trophy[3]] = 0;
        ++$this->trophy[$trophy[3]];
    }
    
    /**
    * добавляет новое сообщение в журнал
    */
    function add_journal($mes) {
        $this->_journal[] = $mes;
    }
    
    /**
    * формирует массив предметов, остающихся на трупе
    */
    function create_items() {
        $items   = array();
        $items[] = 'g.' . $this->gun['gun'].'.0';
        foreach ($this->guns as $gun => $v) {
            $items[] = 'g.' . $gun.'.0';
        }
        foreach ($this->bullets as $bullet => $v) {
            if ($v['cur'] > 0) $items[] = 'c.' . $bullet.'.'.$v['cur'];
        }
        return $items;
    }
    
    /**
    * возвращает содержимое журнала
    *
    * @param string $delim разделитель сообщений
    * @param bool $reverse новые сообщения впереди старых
    */
    function get_journal($delim = '<br />', $reverse = FALSE) {
        if (empty($this->_journal)) return '';
        $s = implode($delim, $reverse ? array_reverse($this->_journal) : $this->_journal);
        $this->_journal = array();
        return $s;
    }
    
    /**
    * добавлении итемсов
    */
    private function _add_item($type) {
        global $items, $bullets;
        
        if (isset($items[$type])) switch ($items[$type]['type']) {
        case 'health':
            if ($this->health < 100) { # можно брать только если здоровье не максимально
                $this->health += $items[$type]['value'];
                if ($this->health >= 100) $this->health = 100;
            } else return FALSE;
            break;
        
        case 'vest':
            if ($this->vest < 100) {
                $this->vest += $items[$type]['value'];
                if ($this->vest >= 100) $this->vest = 100;
            } else return FALSE;
            break;
        
        # добавляет несколько % патронов каждому оружию
        case 'satchel':
            if (isset($this->backpack['satchel'])) return FALSE;
            
            foreach ($this->bullets as $k => $v) {
                $this->bullets[$k]['max'] *= 2;
                $value = intval($v['max'] * $items[$type]['value'] / 100);
                if ($value < 1) $value = 1;
                $this->_add_bullets($k, $value);
            }
            $this->backpack['satchel'] = 1;
            break;
        
        # добавляет ключ в рюкзак
        case 'keys':
            if (isset($this->backpack[$items[$type]['type']][$items[$type]['value']])) {
                return FALSE;
            }
            $this->backpack[$items[$type]['type']][$items[$type]['value']] = 1;
            break;
        
        default:
            if (isset($bullets[$items[$type]['type']])) { # если пули…
                $cur_item = $items[$type];
                return $this->_add_bullets($cur_item['type'], $cur_item['value']);
            } else return FALSE;
        }
        return TRUE;
    }
    
    /**
    * добавление патронов
    */
    private function _add_bullets($type, $value) {
        global $bullets;
        if (isset($bullets[$type])) {
            # количество пуль устанавливается в зависимости от силы
            if ( ! isset($this->bullets[$type])) {
                $this->bullets = $bullets;
                foreach ($bullets as $k => $v) {
                    $v['cur']          = 0;
                    # если есть рюкзак, удваиваем боекомплект
                    if (isset($this->backpack['satchel'])) $v['max'] *= 2;
                    $this->bullets[$k] = $v;
                }
            }
            
            if ($this->bullets[$type]['cur'] >= $this->bullets[$type]['max']) {
                return FALSE;
            }
            
            $this->bullets[$type]['cur'] += $value;
            if ($this->bullets[$type]['cur'] > $this->bullets[$type]['max']) {
                $this->bullets[$type]['cur'] = $this->bullets[$type]['max'];
            }
        } else return FALSE;
        return TRUE;
    }
    
    /**
    * добавляем новое оружие
    *
    * @param string $type добаляемое оружие, $guns[$type]
    * @param bool $cnt сколько патронов добавить (-1 — не добавлять)
    */
    function _add_gun($type, $cnt = -1) {
        global $guns;
        # если оружие существует и у перса его нет
        if (isset($guns[$type]) && ! isset($this->guns[$type])) {
            # также данного оружия не должно быть в руках перса
            if (isset($this->gun['gun']) && $this->gun['gun'] == $type) {
                return FALSE;
            }
            $this->guns[$type] = $guns[$type];
            
            # добавляем патроны
            if ( ! empty($guns[$type]['charger']) && $cnt == -1) {
                $this->_add_bullets($guns[$type]['bullet'], $guns[$type]['charger']);
            }
            
            if ($cnt > 0) $this->_add_bullets($guns[$type]['bullet'], $cnt);
        } else return FALSE;
        
        return TRUE;
    }
}
