<?php
$map = array(
    'name'      => 'Для новичков',
    'desc'      => 'Одна из самых лёгких карт. Все двери открываются без ключей, много разнообразного оружия, включая достаточно мощные экземпляры. Рекомендуется для новичков.',
    'copy'      => 'Основана на первой карте Doom II',
    'time'      => 0, # время начала игры на данной карте
    'width'     => 8,
    'height'    => 8,
    'mapscale'  => 8,
    
    # точки входа
    'enter'     => array(
        array(0,1),
        array(3,0),
        array(5,2),
        array(1,4),
        array(4,4),
    ),
    
    # счёткий убийств (каждому новому трупу присваивается id = $map['frags'],
    # после чего содержимое данного элемента инкрементируется)
    'frags'     => 1,
    
    # счётчик монстров
    'monsters'  => 1,
    
    # список игроков
    'players'   => array(),
    
    # список воскрешения
    'resurrection' => array(),
);

/*
карта покоординатно содержит следующие данные:
    e - локация с выходом (если персонаж выходит, у него остаются только трофеи)
    w - куда можно двигаться
    z - высота (по умолчанию 0. нельзя попасть на более высокую поверхность, кроме как на лифте или через телепорт)
    c - список трупов
        'id'    => уникальный id
        'type'  => 0 (0 - игрок, 1 - npc)
        'name'  => имя перса
        'time'  => время смерти
        'trophy'=> тип оставшегося трофея
        'login' => логин перса
        'items' => array() — список оставшихся предметов
    i - список доступных предметов в локации
        g. - оружие (список находится в файле guns.php)
        i. - что-то, чего можно взять (список находится в файле items.php)
    r - какие предметы через сколько времени появляются вновь (время респауна)
        список в элементами в виде: array(предмет, время_регенерации, время,когда предмет должен появиться на локиции);
    p - игроки, находящиеся в локации
    n — прочие, находящиеся в локации
    
  - в первую очередь обрабатывается "r" (происходит возобновление "i")
    Внимание! на локации не может быть 2 одинаковых предметов!
  - если на локации есть к. л. предметы, персонаж берёт их автоматически.
    количество предметов, которые игрок может взять за 1 ход, определяется его
    ловкостью (на данный момент данная опция зарезервирована на будущее.
    предполагается, что за каждые 5 ловкости игрок сможет брать +1 доп. предмет)
  - в последнюю очередь обрабатывается "c" (через 5 минут исчезают)
*/

# ряд 0
$map[0][0] = array(
    'w' => array(0,0,1,0),
    'z' => 1,
    'c' => array(),
    'i' => array(
        'g.gun2',
        'i.bshot',
    ),
    'r' => array(
        array('g.gun2', 150, 0),
        array('i.bshot', 120, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[1][0] = array(
    'w' => array(0,1,1,0),
    'c' => array(),
    'i' => array(
        'g.gun7',
        'i.mpower',
        'i.bpower',
    ),
    'r' => array(
        array('g.gun7', 200, 0),
        array('i.mpower', 100, 0),
        array('i.bpower', 150, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][0] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][0] = array(
    'w' => array(0,0,1,1),
    'c' => array(),
    'i' => array(
        'i.stimpack',
    ),
    'r' => array(
        array('i.stimpack', 60, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[4][0] = array();
$map[5][0] = array();
$map[6][0] = array();
$map[7][0] = array();

# ряд 1
$map[0][1] = array(
    'w' => array(1,0,1,0),
    'z' => 1,
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[1][1] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.lightvest',
    ),
    'r' => array(
        array('i.lightvest', 100),
    ),
    'p' => array(),
    'n' => array()
);
$map[2][1] = array();
$map[3][1] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[4][1] = array();
$map[5][1] = array();
$map[6][1] = array();
$map[7][1] = array();

# ряд 2
$map[0][2] = array(
    'w' => array(1,1,0,0),
    'z' => 1,
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[1][2] = array(
    'w' => array(1,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[2][2] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][2] = array(
    'w' => array(1,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[4][2] = array(
    'w' => array(0,0,1,1),
    'c' => array(),
    'i' => array(
        'g.gun4',
        'i.mbullet',
        'i.bbullet',
    ),
    'r' => array(
        array('g.gun4', 150),
        array('i.mbullet', 60),
        array('i.bbullet', 120),
    ),
    'p' => array(),
    'n' => array()
);
$map[5][2] = array(
    'w' => array(0,1,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[6][2] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[7][2] = array(
    'w' => array(0,0,1,1),
    'c' => array(),
    'i' => array(
        'i.stimpack',
    ),
    'r' => array(
        array('i.stimpack', 60),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 3
$map[0][3] = array();
$map[1][3] = array(
    'w' => array(0,1,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[2][3] = array(
    'w' => array(0,0,0,1),
    'z' => 1,
    'c' => array(),
    'i' => array(
        'i.lightvest',
    ),
    'r' => array(
        array('i.lightvest', 25),
    ),
    'p' => array(),
    'n' => array()
);
$map[3][3] = array();
$map[4][3] = array(
    'w' => array(1,1,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[5][3] = array(
    'w' => array(1,0,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[6][3] = array();
$map[7][3] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.firstaidkit',
    ),
    'r' => array(
        array('i.firstaidkit', 120),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 4
$map[0][4] = array(
    'w' => array(0,0,1,0),
    'c' => array(),
    'i' => array(
        'g.gun6',
        'i.mpower'
    ),
    'r' => array(
        array('g.gun6', 150),
        array('i.mpower', 150),
    ),
    'p' => array(),
    'n' => array()
);
$map[1][4] = array(
    'w' => array(1,1,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[2][4] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][4] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[4][4] = array(
    'w' => array(1,0,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[5][4] = array(
    'w' => array(1,1,0,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[6][4] = array(
    'w' => array(0,1,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[7][4] = array(
    'w' => array(1,0,0,1), # проход вниз активируется триггером из [6,4]
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);

# ряд 5
$map[0][5] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(
        'i.heavyvest',
    ),
    'r' => array(
        array('i.heavyvest', 200),
    ),
    'p' => array(),
    'n' => array()
);
$map[1][5] = array(
    'w' => array(1,0,1,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[2][5] = array();
$map[3][5] = array();
$map[4][5] = array(
    'w' => array(1,0,0,0), # проход вниз активируется триггером [6][4]
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[5][5] = array();
$map[6][5] = array();
$map[7][5] = array(
    'w' => array(1,0,0,0),
    'c' => array(),
    'i' => array(
        'g.gun3',
        'i.bshot',
    ),
    'r' => array(
        array('g.gun3', 150, 0),
        array('i.bshot', 120, 0),
    ),
    'p' => array(),
    'n' => array()
);

# ряд 6
$map[0][6] = array(
    'w' => array(0,1,0,0), # проход вверх активируется триггером [2][3]
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[1][6] = array(
    'w' => array(1,1,1,1),
/*    'a' => array(
        'Дверь',    # название
        1,          # тип: 1 — дверь с правой стороны локации (может быть активирована из соседней локации справа)
        0,          # текущее положение (внизу)
        0,
        '',
        '',
        0,
        20,
        0,
    ),*/
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[2][6] = array(
    'w' => array(0,0,1,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][6] = array();
$map[4][6] = array(
    'w' => array(1,0,0,0),
    'c' => array(),
    'i' => array(
        'g.gun5',
        'i.brocket',
    ),
    'r' => array(
        array('g.gun5', 175, 0),
        array('i.brocket', 150, 0),
    ),
    'p' => array(),
    'n' => array()
);
$map[5][6] = array();
$map[6][6] = array();
$map[7][6] = array();

# ряд 7
$map[0][7] = array();
$map[1][7] = array(
    'w' => array(1,0,0,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[2][7] = array(
    'w' => array(1,1,0,0),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array()
);
$map[3][7] = array(
    'w' => array(0,0,0,1),
    'c' => array(),
    'i' => array(),
    'r' => array(),
    'p' => array(),
    'n' => array(),
    'e' => 1
);
$map[4][7] = array();
$map[5][7] = array();
$map[6][7] = array();
$map[7][7] = array();

$map['actions'][1][3] = array(
    'Лифт', # название
    1,      # тип: 1 — лифт
    0,      # положение по умолчанию
    0,      # текущее положение (внизу)
    0,      # 1, если допускается только однократное выполнение триггера
    '$map[1][3]["z"]=1;', # код, выполняемый при включении ([3] == 1)
    '$map[1][3]["z"]=0;', # код, выполняемый при выключении ([3] == 0)
    10,     # возвращаться в положение по умолчанию через ? секунд
    0,      # время последней активации
);

$map['actions'][2][3] = array(
    'Рубильник',
    2,      # тип: 2 — кнопка, рубильник и т. д. (доступ только из текущей локации)
    0,
    0,
    1,
    '$map[0][6]["w"][0]=1;'
);

$map['actions'][6][4] = array(
    'Рубильник',
    2,
    0,
    0,
    1,
    '$map[7][4]["w"][2]=1; $map[4][5]["w"][2]=1;'
);


# двери (проверят для каждой локации посредством isset: $map['doors'][x+0.5][y],[x-0.5][y],[x][y+0.5],[x][y-0.5])
$map['doors']['4.5'][3] = array(
    'name' => 'Дверь',    # название
    'type' => '',         # тип ('' - обычная дверь, ykey - для открытия нужен жёлтый ключ, bkey - синий, rkey - красный)
    'open' => 0,          # текущее положение (закрыта)
    'ret'  => 20,         # время возврата в умолчательное состояние
    'time' => 0,          # время последней активации
);

$map['doors']['1.5'][6] = array(
    'name' => 'Дверь',
    'type' => '',
    'open' => 0,
    'ret'  => 20,
    'time' => 0,
);

# порталы
$map['portal'][4][6] = array(
    'Телепорт',
    0,          # точка выхода x
    1,          # точка выхода y
);

# npc
$map['npc'] = array(
    $map['monsters']++ => array(
        'type'          => 'zombiesergeant',
        'loc'           => array(0,0),      # где находится
        'rloc'          => array(4,2),      # где появляется
        'time'          => 0,               # время последней активности
        'resurrection'  => 45,              # время воскрешения, секунд (если ноль, то не воскресает)
        'rtime'         => 1,               # время, когда npc должен воскреснуть (если поставить 0, то никогда не воскреснет!)
        'npc'           => NULL,            # информация о типе npc (из $npc)
    ),
    $map['monsters']++ => array(
        'type'          => 'imp',
        'loc'           => array(0,0),
        'rloc'          => array(1,7),
        'time'          => 0,
        'resurrection'  => 60,
        'rtime'         => 1,
        'npc'           => NULL,
    ),
    $map['monsters']++ => array(
        'type'          => 'zombie',
        'loc'           => array(0,0),
        'rloc'          => array(5,2),
        'time'          => 0,
        'resurrection'  => 30,
        'rtime'         => 1,
        'npc'           => NULL,
    ),
    $map['monsters']++ => array(
        'type'          => 'zombie',
        'loc'           => array(0,0),
        'rloc'          => array(7,3),
        'time'          => 0,
        'resurrection'  => 30,
        'rtime'         => 1,
        'npc'           => NULL,
    ),
    $map['monsters']++ => array(
        'type'          => 'zombie',
        'loc'           => array(0,0),
        'rloc'          => array(3,4),
        'time'          => 0,
        'resurrection'  => 30,
        'rtime'         => 1,
        'npc'           => NULL,
    ),
    $map['monsters']++ => array(
        'type'          => 'zombie',
        'loc'           => array(0,0),
        'rloc'          => array(2,3),
        'time'          => 0,
        'resurrection'  => 30,
        'rtime'         => 1,
        'npc'           => NULL,
    ),
    $map['monsters']++ => array(
        'type'          => 'zombie',
        'loc'           => array(0,0),
        'rloc'          => array(2,2),
        'time'          => 0,
        'resurrection'  => 30,
        'rtime'         => 1,
        'npc'           => NULL,
    ),
    $map['monsters']++ => array(
        'type'          => 'zombie',
        'loc'           => array(0,0),
        'rloc'          => array(0,4),
        'time'          => 0,
        'resurrection'  => 30,
        'rtime'         => 1,
        'npc'           => NULL,
    ),
);
