<?php
require 'header.php';

$top  = '';

if (empty($_SESSION[SESNAME]['file'])) { # если пользователь не авторизован, выход
    header('Location: index.php?' . SESNAME . '=' . SESID . '&' . rand());
    exit;
}

if (isset($_GET['map'])) { # позиция на карте
    $map_name = 'img/map/'.preg_replace('/[^a-zA-Z0-9_-]/', '', $_GET['map']).'.png';
    $scale = isset($_GET['scale']) ? (int) $_GET['scale'] : 0;
    if (isset($_GET['pos'])) list($x, $y) = explode(',', $_GET['pos']);
    else list($x, $y) = array(0, 0);
    
    if (file_exists($map_name) && $scale && $x >= 0 && $y >= 0) {
        $im = imagecreatefrompng($map_name);
        imagefilledrectangle($im, $x*$scale,$y*$scale,($x+1)*$scale-1,($y+1)*$scale-1,0);
        header('Content-type:image/png');
        imagepng($im);
    } else header('HTTP/1.1 404 Not Found'); 
    exit;
}

$game_file = $_SESSION[SESNAME]['file'];
if (file_exists($game_file)) {
    $fileg = fopen($game_file, 'r+');
    flock($fileg, LOCK_EX);
    
    $map        = unserialize(fread($fileg, filesize($game_file)));
    $map['time']= ITIME;
    $user       = $map['players'][$_SESSION[SESNAME]['name']];
    $last_time  = $user->time;
    $journal    = '';
    
    if (isset($_GET['resurrect']) && $user->health <=0) $user->initialize();
    if (empty($user->loc)) {
        $epoint = $map['enter'][rand(0, count($map['enter']) - 1)];
        $user->loc = $epoint;
        add_all_journal($epoint, 'Появился ' . htmlspecialchars($user->name));
        $map[$epoint[0]][$epoint[1]]['p'][$user->login] = 1;
    }
    
    if ($user->health <= 0) { # если убит
        $journal = $user->get_journal();
        if ( ! empty($journal)) {
            $content .= '<p><strong>Журнал</strong><br />'.$journal.'</p>';
        }
        $content .= '<p>Вы убиты. <a href="?resurrect=1&amp;'.rand().'">В бой!</a></p>';
        $user_dead = 1;
    } elseif (isset($_GET['exit'])) { # если команда на выход
        $x = $user->loc[0]; # положение юзера по горизонтали
        $y = $user->loc[1]; # положение юзера по вертикали
        
        if (isset($map[$x][$y]['e']) || $user->login == 'admin') {
            unset($map[$x][$y]['p'][$user->login]);
            unset($map['players'][$user->login]);
            # записываем состояние
            $user->loc = array();
            $user->save_state();
            # из сессии требуется удалить признак того, что пользователь
            # находится на к. л. карте
            unset($_SESSION[SESNAME]['map']);
            unset($_SESSION[SESNAME]['file']);
			add_all_journal(array(), '<strong>'.htmlspecialchars($name) . '</strong> покинул Арену');
        } else {
            header('Location: ?' . rand());
            exit;
        }
    } else { # дальше идёт обработка разнообразных событий
        $x     = $user->loc[0]; # положение юзера по горизонтали
        $y     = $user->loc[1]; # положение юзера по вертикали
        $w     = $map['width']; # ширина карты
        $h     = $map['height'];# высота карты
        
        # сохраняем предыдущее значение координат (чтобы «переместить» юзера
        # в новую локацию)
        $old_x = $x;
        $old_y = $y;
        
        # если время позволяет, анализируем действия перса: движение, стрельба, воздействие на экшны, подбор трофеев
        if (ATIME - $user->time >= ACTIME || $user->login == 'admin') {
            $user->time = ATIME;
            if (isset($_GET['move'])) { # если дана команда на движение
                switch ($_GET['move']) {
                case 'n': # север
                    # а ведь ещё требуются проверки дверей (экшны можно не проверять,
                    # т. к. лифт устанавливает высоту локации)
                    if (isset($map[$x][$y - 1]) && isset($map[$x][$y]) && $map[$x][$y]['w'][0]) {
                        $z  = empty($map[$x][$y]['z'])     ? 0 : $map[$x][$y]['z'];
                        $nz = empty($map[$x][$y - 1]['z']) ? 0 : $map[$x][$y - 1]['z'];
                        if ($z >= $nz) {
                            $door_coord = (string) ($y - 0.5);
                            # теперь остаётся проверить дверь
                            if ( ! isset($map['doors'][$x][$door_coord])) $open = 1;
                            else $open = $map['doors'][$x][$door_coord]['open'];
                            
                            if ($open) {
                                --$y;
                                $user->loc[1] = $y;
                            }
                        } else $user->add_journal('Нельзя двигаться на Север');
                    } else $user->add_journal('Нельзя двигаться на Север');
                    break;
                case 'e': # восток
                    if (isset($map[$x + 1][$y]) && isset($map[$x][$y]) && $map[$x][$y]['w'][1]) {
                        $z  = empty($map[$x][$y]['z'])     ? 0 : $map[$x][$y]['z'];
                        $ez = empty($map[$x + 1][$y]['z']) ? 0 : $map[$x + 1][$y]['z'];
                        if ($z >= $ez) {
                            $door_coord = (string) ($x + 0.5);
                            if ( ! isset($map['doors'][$door_coord][$y])) $open = 1;
                            else $open = $map['doors'][$door_coord][$y]['open'];
                            
                            if ($open) {
                                ++$x;
                                $user->loc[0] = $x;
                            }
                        } else $user->add_journal('Нельзя двигаться на Восток');
                    } else $user->add_journal('Нельзя двигаться на Восток');
                    break;
                case 's': # юг
                    if (isset($map[$x][$y + 1]) && isset($map[$x][$y]) && $map[$x][$y]['w'][2]) {
                        $z  = empty($map[$x][$y]['z'])     ? 0 : $map[$x][$y]['z'];
                        $sz = empty($map[$x][$y + 1]['z']) ? 0 : $map[$x][$y + 1]['z'];
                        if ($z >= $sz) {
                            $door_coord = (string) ($y + 0.5);
                            if ( ! isset($map['doors'][$x][$door_coord])) $open = 1;
                            else $open = $map['doors'][$x][$door_coord]['open'];
                            
                            if ($open) {
                                ++$y;
                                $user->loc[1] = $y;
                            }
                        } else $user->add_journal('Нельзя двигаться на Юг');
                    } else $user->add_journal('Нельзя двигаться на Юг');
                    break;
                case 'w': # запад
                    if (isset($map[$x - 1][$y]) && isset($map[$x][$y]) && $map[$x][$y]['w'][3]) {
                        $z  = empty($map[$x][$y]['z'])     ? 0 : $map[$x][$y]['z'];
                        $wz = empty($map[$x - 1][$y]['z']) ? 0 : $map[$x - 1][$y]['z'];
                        if ($z >= $wz) {
                            $door_coord = (string) ($x - 0.5);
                            if ( ! isset($map['doors'][$door_coord][$y])) $open = 1;
                            else $open = $map['doors'][$door_coord][$y]['open'];
                            
                            if ($open) {
                                --$x;
                                $user->loc[0] = $x;
                            }
                        } else $user->add_journal('Нельзя двигаться на Запад');
                    } else $user->add_journal('Нельзя двигаться на Запад');
                    break;
                }
                
                if (isset($door)) unset($door);
            } elseif (isset($_GET['act'])) {
                switch ($_GET['act']) {
                case 'n': # активировать экшн (лифт) на севере
                    if (isset($map['actions'][$x][$y - 1])) {
                        $action =& $map['actions'][$x][$y - 1];
                        if ($action[4] == 1 && $action[3] != $action[2]) {
                            $user->add_journal($action[0] . ', нельзя активировать повторно');
                        } else {
                            $action[3] = ! $action[3];
                            $code = $action[5 + empty($action[3])];
                            if ( ! empty($code)) eval($code);
                            if ( ! $action[4]) $action[8] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $action[0] . ' [с]');
                        }
                        unset($action);
                    }
                    break;
                
                case 'e': # активировать на востоке
                    if (isset($map['actions'][$x + 1][$y])) {
                        $action =& $map['actions'][$x + 1][$y];
                        if ($action[4] == 1 && $action[3] != $action[2]) {
                            $user->add_journal($action[0] . ', нельзя активировать повторно');
                        } else {
                            $action[3] = ! $action[3];
                            $code = $action[5 + empty($action[3])];
                            if ( ! empty($code)) eval($code);
                            if ( ! $action[4]) $action[8] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $action[0] . ' [в]');
                        }
                        unset($action);
                    }
                    break;
                
                case 's': # активировать на юге
                    if (isset($map['actions'][$x][$y + 1])) {
                        $action =& $map['actions'][$x][$y + 1];
                        if ($action[4] == 1 && $action[3] != $action[2]) {
                            $user->add_journal($action[0] . ', нельзя активировать повторно');
                        } else {
                            $action[3] = ! $action[3];
                            $code = $action[5 + empty($action[3])];
                            if ( ! empty($code)) eval($code);
                            if ( ! $action[4]) $action[8] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $action[0] . ' [ю]');
                        }
                        unset($action);
                    }
                    break;
                
                case 'w': # активировать на западе
                    if (isset($map['actions'][$x - 1][$y])) {
                        $action =& $map['actions'][$x - 1][$y];
                        if ($action[4] == 1 && $action[3] != $action[2]) {
                            $user->add_journal($action[0] . ', нельзя активировать повторно');
                        } else {
                            $action[3] = ! $action[3];
                            $code = $action[5 + empty($action[3])];
                            if ( ! empty($code)) eval($code);
                            if ( ! $action[4]) $action[8] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $action[0] . ' [з]');
                        }
                        unset($action);
                    }
                    break;
                
                case '1': # активировать экшн в текущей локации
                    if (isset($map['actions'][$x][$y])) {
                        $action =& $map['actions'][$x][$y];
                        if ($action[4] == 1 && $action[3] != $action[2]) {
                            $user->add_journal($action[0] . ', нельзя активировать повторно');
                        } else {
                            $action[3] = ! $action[3];
                            $code = $action[5 + empty($action[3])];
                            if ( ! empty($code)) eval($code);
                            # время имеет смысл устанавливать только для
                            # многократно инициируемых триггеров
                            if ( ! $action[4]) $action[8] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $action[0]);
                        }
                        unset($action);
                    }
                    break;
                }
            } elseif (isset($_GET['door'])) {
                switch ($_GET['door']) {
                case 0: # север
                    $door_coord = (string) ($y - 0.5);
                    if (isset($map['doors'][$door_coord][$y])) {
                        $door = $map['doors'][$door_coord][$y];
                        if ($user->is_key($door['type'])) {
                            $map['doors'][$x][$door_coord]['open'] = ! $door[$door_coord]['open'];
                            $map['doors'][$x][$door_coord]['time'] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $door['name'] . ' [с]');
                            $t_loc = $user->loc;
                            if ($t_loc[1] > 0) {
                                $t_loc[1] -= 1;
                                add_all_journal($t_loc, 'Кто-то активировал ' . $door['name'] . ' [ю]');
                            }
                        } else {
                            if (isset($items[$door['type']])) {
                                $user->add_journal('Для активации двери требуется ' . $items[$door['type']]['name']);
                            } else {
                                $user->add_journal('Невозможно активировать дверь');
                            }
                        }
                    }
                    break;
                
                case 1: # восток
                    $door_coord = (string) ($x + 0.5);
                    if (isset($map['doors'][$door_coord][$y])) {
                        $door = $map['doors'][$door_coord][$y];
                        if ($user->is_key($door['type'])) {
                            $map['doors'][$door_coord][$y]['open'] = ! $door['open'];
                            $map['doors'][$door_coord][$y]['time'] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $door['name'] . ' [в]');
                            $t_loc = $user->loc;
                            if ($t_loc[0] < $w - 1) {
                                $t_loc[0] += 1;
                                add_all_journal($t_loc, 'Кто-то активировал ' . $door['name'] . ' [з]');
                            }
                        } else {
                            if (isset($items[$door['type']])) {
                                $user->add_journal('Для активации двери требуется ' . $items[$door['type']]['name']);
                            } else {
                                $user->add_journal('Невозможно активировать дверь');
                            }
                        }
                    }
                    break;
                
                case 2: # юг
                    $door_coord = (string) ($y + 0.5);
                    if (isset($map['doors'][$door_coord][$y])) {
                        $door = $map['doors'][$door_coord][$y];
                        if ($user->is_key($door['type'])) {
                            $map['doors'][$x][$door_coord]['open'] = ! $door['open'];
                            $map['doors'][$x][$door_coord]['time'] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $door['name'] . ' [ю]');
                            $t_loc = $user->loc;
                            if ($t_loc[1] < $h - 1) {
                                $t_loc[1] += 1;
                                add_all_journal($t_loc, 'Кто-то активировал ' . $door['name'] . ' [с]');
                            }
                        } else {
                            if (isset($items[$door['type']])) {
                                $user->add_journal('Для активации двери требуется ' . $items[$door['type']]['name']);
                            } else {
                                $user->add_journal('Невозможно активировать дверь');
                            }
                        }
                    }
                    break;
                
                case 3: # запад
                    $door_coord = (string) ($x - 0.5);
                    if (isset($map['doors'][$door_coord][$y])) {
                        $door = $map['doors'][$door_coord][$y];
                        if ($user->is_key($door['type'])) {
                            $map['doors'][$door_coord][$y]['open'] = ! $door['open'];
                            $map['doors'][$door_coord][$y]['time'] = ITIME;
                            add_all_journal($user->loc, htmlspecialchars($user->login) . ' активировал ' . $door['name'] . ' [з]');
                            $t_loc = $user->loc;
                            if ($t_loc[0] > 0) {
                                $t_loc[0] -= 1;
                                add_all_journal($t_loc, 'Кто-то активировал ' . $door['name'] . ' [в]');
                            }
                        } else {
                            if (isset($items[$door['type']])) {
                                $user->add_journal('Для активации двери требуется ' . $items[$door['type']]['name']);
                            } else {
                                $user->add_journal('Невозможно активировать дверь');
                            }
                        }
                    }
                    break;
                }
            } elseif (isset($_GET['gun'])) { # смена оружия
                $_get_gun = preg_replace('/[^0-9a-zA-Z_-]/', '', $_GET['gun']);
                if ( ! $user->change_gun($_get_gun)) {
                    $user->add_journal('Нельзя сменить оружие на ' . $_get_gun);
                }
            } elseif (isset($_GET['portal'])) { # телепортация
                if (isset($map['portal'][$x][$y])) {
                    $portal         = $map['portal'][$x][$y];
                    list($t, $x, $y)= $portal;
                    $user->loc      = array($x, $y);
                    change_loc(array($old_x, $old_y));
                    add_all_journal(array($old_x, $old_y), htmlspecialchars($user->name) . ' вошёл в ' . $portal[0]);
                }
            } elseif (isset($_GET['c'])) { # обыск трупа
                if ( ! empty($map[$x][$y]['c'])) {
                    foreach ($map[$x][$y]['c'] as $k => $v) {
                        if ($v['id'] == $_GET['c']) {
                            $cnt = 0;
                            # трофеи остаются только от убитых персов; npc трофеи не оставляют
                            if ($v['trophy'] && empty($v['type']) && $user->login != $v['login']) {
                                $user->add_trophy($v);
                                $map[$x][$y]['c'][$k]['type'] = 0;
                                $user->add_journal('Найден трофей: ' . $trophy[$v['trophy']]['name']);
                                $map[$x][$y]['c'][$k]['trophy'] = '';
                                ++$cnt;
                            }
                            if ( ! empty($v['items'])) foreach ($v['items'] as $k2 => $item) {
                                # смотрим, есть ли что в рюкзаке
                                $item_name = $user->add_item($item);
                                if ($item_name !== FALSE) {
                                    ++$cnt;
                                    $user->add_journal('Найдено: ' . $item_name);
                                    unset($map[$x][$y]['c'][$k]['items'][$k2]);
                                }
                            }
                            
                            if (empty($cnt)) $user->add_journal('Обыск ничего не дал');
                            break;
                        }
                    }
                }
            } elseif (isset($_GET['attack']) && isset($_GET['n'])) { # атака npc
                $npc_at = (int) $_GET['attack'];
                if (isset($map['npc'][$npc_at])) {
                    $anpc = $map['npc'][$npc_at];
                    if (array($x, $y) == $anpc['loc'] && $anpc['npc']['health'] > 0) {
                        npc_attack($npc_at);
                    } else {
                        if (empty($user->gun['noranged'])) { # оружие ближнего боя
                            # нельзя атаковать противника, находящегося выше
                            $z  = empty($map[$x][$y]['z'])    ? 0   : $map[$x][$y]['z'];
                            $nz = empty($map[$x][$y]['w'][0]) ? 999 : (empty($map[$x][$y - 1]['z']) ? 0 : $map[$x][$y - 1]['z']);
                            $ez = empty($map[$x][$y]['w'][1]) ? 999 : (empty($map[$x + 1][$y]['z']) ? 0 : $map[$x + 1][$y]['z']);
                            $sz = empty($map[$x][$y]['w'][2]) ? 999 : (empty($map[$x][$y + 1]['z']) ? 0 : $map[$x][$y + 1]['z']);
                            $wz = empty($map[$x][$y]['w'][3]) ? 999 : (empty($map[$x - 1][$y]['z']) ? 0 : $map[$x - 1][$y]['z']);
                            
                            # если противник на севере
                            if ($map[$x][$y]['w'][0] && $anpc['loc'] == array($x, $y - 1) && $z >= $nz) {
                                $door_coord = (string) ($y - 0.5);
                                if (isset($map['doors'][$x][$door_coord]) && empty($map['doors'][$x][$door_coord][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    npc_attack($npc_at);
                                }
                            } elseif ($map[$x][$y]['w'][1] && $anpc['loc'] == array($x + 1, $y) && $z >= $ez) {
                                $door_coord = (string) ($x + 0.5);
                                if (isset($map['doors'][$door_coord][$y]) && empty($map['doors'][$door_coord][$y][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    npc_attack($npc_at);
                                }
                            } elseif ($map[$x][$y]['w'][2] && $anpc['loc'] == array($x, $y + 1) && $z >= $sz) {
                                $door_coord = (string) ($y + 0.5);
                                if (isset($map['doors'][$x][$door_coord]) && empty($map['doors'][$x][$door_coord][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    npc_attack($npc_at);
                                }
                            } elseif ($map[$x][$y]['w'][3] && $anpc['loc'] == array($x - 1, $y) && $z >= $wz) {
                                $door_coord = (string) ($x - 0.5);
                                if (isset($map['doors'][$door_coord][$y]) && empty($map['doors'][$door_coord][$y][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    npc_attack($npc_at);
                                }
                            } else $user->add_journal($anpc['npc']['name'] . ' ушёл с линии атаки');
                        } else $user->add_journal('Нельзя атаковать оружием ближнего боя противников на соседних локациях');
                    }
                } else $user->add_journal('Некого атаковать');
            } elseif (isset($_GET['attack'])) { # атака
                if (isset($map['players'][$_GET['attack']])) {
                    $auser = $map['players'][$_GET['attack']];
                    if ($user->loc == $auser->loc) {
                        user_attack($auser);
                    } else {
                        if (empty($user->gun['noranged'])) { # оружие ближнего боя
                            # нельзя атаковать противника, находящегося выше
                            $z  = empty($map[$x][$y]['z'])    ? 0   : $map[$x][$y]['z'];
                            $nz = empty($map[$x][$y]['w'][0]) ? 999 : (empty($map[$x][$y - 1]['z']) ? 0 : $map[$x][$y - 1]['z']);
                            $ez = empty($map[$x][$y]['w'][1]) ? 999 : (empty($map[$x + 1][$y]['z']) ? 0 : $map[$x + 1][$y]['z']);
                            $sz = empty($map[$x][$y]['w'][2]) ? 999 : (empty($map[$x][$y + 1]['z']) ? 0 : $map[$x][$y + 1]['z']);
                            $wz = empty($map[$x][$y]['w'][3]) ? 999 : (empty($map[$x - 1][$y]['z']) ? 0 : $map[$x - 1][$y]['z']);
                            
                            # если противник на севере
                            if ($map[$x][$y]['w'][0] && $auser->loc == array($x, $y - 1) && $z >= $nz) {
                                $door_coord = (string) ($y - 0.5);
                                if (isset($map['doors'][$x][$door_coord]) && empty($map['doors'][$x][$door_coord][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    user_attack($auser);
                                }
                            } elseif ($map[$x][$y]['w'][1] && $auser->loc == array($x + 1, $y) && $z >= $ez) {
                                $door_coord = (string) ($x + 0.5);
                                if (isset($map['doors'][$door_coord][$y]) && empty($map['doors'][$door_coord][$y][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    user_attack($auser);
                                }
                            } elseif ($map[$x][$y]['w'][2] && $auser->loc == array($x, $y + 1) && $z >= $sz) {
                                $door_coord = (string) ($y + 0.5);
                                if (isset($map['doors'][$x][$door_coord]) && empty($map['doors'][$x][$door_coord][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    user_attack($auser);
                                }
                            } elseif ($map[$x][$y]['w'][3] && $auser->loc == array($x - 1, $y) && $z >= $wz) {
                                $door_coord = (string) ($x - 0.5);
                                if (isset($map['doors'][$door_coord][$y]) && empty($map['doors'][$door_coord][$y][2])) {
                                    $user->add_journal('Нельзя атаковать через дверь');
                                } else {
                                    user_attack($auser);
                                }
                            } else $user->add_journal(htmlspecialchars($auser->name) . ' ушёл с линии атаки');
                        } else $user->add_journal('Нельзя атаковать оружием ближнего боя противников на соседних локациях');
                    }
                } else $user->add_journal('Некого атаковать');
            } else {}
            
            change_loc(array($old_x, $old_y));
            
            # убираем трупы
            if ( ! empty($map[$x][$y]['c'])) foreach ($map[$x][$y]['c'] as $k => $v) {
                if ($v['time'] + $cfg['corp'] < ITIME) {
                    unset($map[$x][$y]['c'][$k]);
                    add_all_journal(array($x, $y), 'Исчез труп ' . $v['name']);
                }
            }
            
            check_doors($x, $y);      # проверка дверей на соседние локации
            check_action($x, $y);     # проверка экшнов в текущей локации
            check_action($x, $y - 1); # экшны в локации на севере
            check_action($x + 1, $y); # экшны в локации на востоке
            check_action($x, $y + 1); # экшны в локации на юге
            check_action($x - 1, $y); # экшны в локации на западе
            
            # некоторые вещи могут появляться…
            if ( ! empty($map[$x][$y]['r'])) foreach ($map[$x][$y]['r'] as $k => $v) {
                if ( ! empty($v[2]) && $v[2] < ITIME) {
                    $map[$x][$y]['i'][] = $v[0];
                    $map[$x][$y]['r'][$k][2] = 0;
                }
            }
            
            # подбираем вещи, разбросанные на локации (количество зависит
            # от ловкости: каждые 5 ловкости = +1 вещь)
            if ( ! empty($map[$x][$y]['i'])) {
                $max_item  = intval(($user->agility + ($user->agility % 5 ? 5 : 0)) / 5);
                $curr_item = 0;
                foreach ($map[$x][$y]['i'] as $k => $item) {
                    $item_name = $user->add_item($item);
                    if ($item_name !== FALSE) {
                        ++$curr_item;
                        foreach ($map[$x][$y]['r'] as $k2 => $v) {
                            if ($v[0] == $item) {
                                # установим время, когда должны появиться итемсы
                                $map[$x][$y]['r'][$k2][2] = ITIME + $map[$x][$y]['r'][$k2][1];
                                break;
                            }
                        }
                        $user->add_journal('Взято: ' . $item_name);
                        unset($map[$x][$y]['i'][$k]);
                        if ($curr_item >= $max_item) break;
                    }
                }
            }
        } else {
            $user->add_journal('Слишком быстро двигаетесь. Перерыв между действиями должен составлять не менее '.ACTIME.' секунд');
        }
        
        # проверка высот локаций
        $z  = empty($map[$x][$y]['z']) ? 0 : $map[$x][$y]['z']; # высота
        $nz = $y < 1      ? 999 : (empty($map[$x][$y - 1]['z']) ? 0 : $map[$x][$y - 1]['z']); # высота локации на севере
        $sz = $y > $h - 1 ? 999 : (empty($map[$x][$y + 1]['z']) ? 0 : $map[$x][$y + 1]['z']); # высота локации на юге
        $ez = $x > $w - 1 ? 999 : (empty($map[$x + 1][$y]['z']) ? 0 : $map[$x + 1][$y]['z']); # высота локации на западе
        $wz = $x < 1      ? 999 : (empty($map[$x - 1][$y]['z']) ? 0 : $map[$x - 1][$y]['z']); # высота локации на востоке
        
        # смотрим, есть ли npc, требующие воскрешения
        foreach ($map['npc'] as $k => $v) {
            if (isset($npc[$v['type']]) && $v['rtime'] && $v['rtime'] < ATIME) {
                if ($v['resurrection']) {
                    list($npc_x, $npc_y) = $v['rloc'];
                    $map['npc'][$k]['rtime']        = 0; # npc восстановлен
                    $map['npc'][$k]['loc']          = $map['npc'][$k]['rloc'];
                    $map['npc'][$k]['npc']          = $npc[$v['type']];
                    $map[$npc_x][$npc_y]['n'][$k]   = 1; # размещение npc
                }
            }
        }
        
        $loc =& $map[$x][$y];
        $top .= "<p>[$x, $y], ".date('H:i:s', ITIME)."</p><hr />";
        
        $map_file = preg_replace('/[^a-zA-Z0-9_-]/', '', $_SESSION[SESNAME]['map']);
        $content .= '<img alt="" src="?map='.$map_file.'&amp;scale='.$map['mapscale'].'&amp;pos='.$x.','.$y.'"><br />';
        
        $user_str  = '';
        $user_str .= get_users($x, $y);
        
        $npc_str   = '';
        $npc_str .= get_npc($x, $y);
        
        if ( ! empty($loc['e'])) {
            $content .= '<a href="?exit=1&amp;'.rand().'">[Выход]</a><br />';
        }
        
        # анализируем текущую локацию на наличие экшнов (кнопка, лифт и т. д.)
        if (isset($map['actions'][$x][$y])) {
            $content .= '<p><strong>Рядом</strong><br />';
            $action = $map['actions'][$x][$y];
            # если допускается однократное активирование и текущая позиция не
            # равна умолчательной, считаем, что уже активировано
            if ($action[4] == 1 && $action[3] != $action[2]) {
                $content .= $action[0].' (активировано)';
            } else {
                $content .= '<a href="?act=1&amp;'.rand().'">'.$action[0].' (активация)</a>';
            }
            $content .= '</p>';
            unset($action);
        }
        
        # смотрим, есть ли в локации портал
        if (isset($map['portal'][$x][$y])) {
            $portal = $map['portal'][$x][$y];
            $content .= '<a href="?portal=1&amp;'.rand().'">'.'В '.$map['portal'][$x][$y][0].'</a><br />';
        }
        
        # выводим список трупов
        if ( ! empty($loc['c'])) {
            $content .= '<p>';
            foreach ($loc['c'] as $v) {
                #if ($v[4] == $user->login) $content .= 'Труп '.$v['name'] . '<br />';
                #else
                    $content .= 'Труп '.$v['name'] . ' <a href="?c='.$v['id'].'">обыскать</a><br />';
            }
            $content .= '</p>';
        }
        
        $content .= '<p><strong>Действия</strong><br />';
        
        # смотрим, есть ли двери
        $doors = create_map_doors($x, $y);
        
        # установим признак, разрешающий движение в соответствующую сторону
        $moves = create_map_moves($x, $y);
        
        # ←↑→↓
        # смотрим, разрешено ли движение вверх
        # заодно формируем список противников
        if ($loc['w'][0]) {
            if (isset($map['actions'][$x][$y - 1])) {
                $action = $map['actions'][$x][$y - 1];
            }
            $s = '';
            # проверяем локацию на севере
            if ($z >= $nz) {
                if (empty($doors[0]) || $doors[0]['open']) {
                    $s .= '[↑] <a href="?move=n&amp;'.rand().'">Север</a> ';
                    $user_str .= get_users($x, $y - 1, ' [с]');
                    $npc_str  .= get_npc($x, $y - 1, ' [с]');
                }
                
                # если есть дверь, проверяем, можно ли её активировать
                if (isset($doors[0])) {
                    if ($user->is_key($doors[0]['type'])) {
                        $s .= '<a href="?door=0&amp;'.rand().'">'.$doors[0]['name'].', активировать [с]</a>';
                    } else {
                        if (isset($items[$doors[0]['type']]['name'])) {
                            $s .= $doors[0]['name'] . ' [с], для активации требуется ' . $items[$doors[0]['type']]['name'];
                        }
                    }
                }
                
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано)';
                    } else {
                        $s .= '<a href="?act=n&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            } else { # может быть в случае, если лифт недоступен
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано)';
                    } else {
                        $s .= '<a href="?act=n&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            }
            
            if (isset($action)) unset($action);
            if ($s) $content .= $s . '<br />';
        }
        
        # движение вправо
        if ($loc['w'][1]) {
            if (isset($map['actions'][$x - 1][$y])) {
                $action = $map['actions'][$x - 1][$y];
            }
            $s = '';
            # проверяем локацию на западе
            if ($z >= $ez) {
                if (empty($doors[1]) || $doors[1]['open']) {
                    $s .= '[→] <a href="?move=e&amp;'.rand().'">Восток</a> ';
                    $user_str .= get_users($x + 1, $y, ' [в]');
                    $npc_str  .= get_npc($x + 1, $y, ' [в]');
                }
                
                if (isset($doors[1])) {
                    if ($user->is_key($doors[1]['type'])) {
                        $s .= '<a href="?door=1&amp;'.rand().'">'.$doors[1]['name'].', активировать [в]</a>';
                    } else {
                        if (isset($items[$doors[1]['type']]['name'])) {
                            $s .= $doors[1]['name'] . ' [в], для активации требуется ' . $items[$doors[1]['type']]['name'];
                        }
                    }
                }
                
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано)';
                    } else {
                        $s .= '<a href="?act=e&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            } else { # может быть в случае, если лифт недоступен
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано)';
                    } else {
                        $s .= '<a href="?act=e&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            }
            
            if (isset($action)) unset($action);
            if ($s) $content .= $s . '<br />';
        }
        
        # движение вниз
        if ($loc['w'][2]) {
            if (isset($map['actions'][$x][$y + 1])) {
                $action = $map['actions'][$x][$y + 1];
            }
            $s = '';
            # проверяем локацию на севере
            if ($z >= $sz) {
                if (empty($doors[2]) || $doors[2]['open']) {
                    $s .= '[↓] <a href="?move=s&amp;'.rand().'">Юг</a> ';
                    $user_str .= get_users($x, $y + 1, ' [ю]');
                    $npc_str  .= get_npc($x, $y + 1, ' [ю]');
                }
                
                if (isset($doors[2])) {
                    if ($user->is_key($doors[2]['type'])) {
                        $s .= '<a href="?door=2&amp;'.rand().'">'.$doors[2]['name'].', активировать [ю]</a>';
                    } else {
                        if (isset($items[$doors[2]['type']]['name'])) {
                            $s .= $doors[2]['name'] . ' [ю], для активации требуется ' . $items[$doors[2]['type']]['name'];
                        }
                    }
                }
                
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано)';
                    } else {
                        $s .= '<a href="?act=s&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            } else { # может быть в случае, если лифт недоступен
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано)';
                    } else {
                        $s .= '<a href="?act=s&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            }
            
            
            if (isset($action)) unset($action);
            if ($s) $content .= $s . '<br />';
        }
        
        # движение влево
        if ($loc['w'][3]) {
            if (isset($map['actions'][$x - 1][$y])) {
                $action = $map['actions'][$x - 1][$y];
            }
            $s = '';
            # проверяем локацию на западе
            if ($z >= $wz) {
                if (empty($doors[3]) || $doors[3]['open']) {
                    $s .= '[←] <a href="?move=w&amp;'.rand().'">Запад</a> ';
                    $user_str .= get_users($x - 1, $y, ' [з]');
                    $npc_str  .= get_npc($x - 1, $y, ' [з]');
                }
                
                if (isset($doors[3])) {
                    if ($user->is_key($doors[3]['type'])) {
                        $s .= '<a href="?door=3&amp;'.rand().'">'.$doors[3]['name'].', активировать [з]</a>';
                    } else {
                        if (isset($items[$doors[3]['type']]['name'])) {
                            $s .= $doors[3]['name'] . ' [з], для активации требуется ' . $items[$doors[3]['type']]['name'];
                        }
                    }
                }
                
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано1)';
                    } else {
                        $s .= '<a href="?act=w&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            } else { # может быть в случае, если лифт недоступен
                if (isset($action) && $action[1] == 1) {
                    if ($action[4] == 1 && $action[3] != $action[2]) {
                        $s .= $action[0].' (активировано)';
                    } else {
                        $s .= '<a href="?act=w&amp;'.rand().'">'.$action[0].' (активация)</a>';
                    }
                }
            }
            
            if (isset($action)) unset($action);
            if ($s) $content .= $s . '<br />';
        }
        
        if ($user_str || $npc_str) {
            $content .= '<p><strong>Рядом</strong><br />'.$npc_str.($user_str?$user_str:'').'</p>';
        }
        
        $content .= '</p>'; # блок Действия
        
        # если на локации есть к. л. предметы, выводим их названия (брать ничего
        # не нужно, т. к. это происходит автоматически)
        if ( ! empty($loc['i'])) {
            $t = array();
            foreach ($loc['i'] as $item) {
                list($type, $item_name) = explode('.', $item, 2);
                
                switch ($type) {
                case 'i': $s = isset($items[$item_name]) ? $items[$item_name]['name'] : '';
                    break;
                case 'g': $s = isset($guns[$item_name]) ? $guns[$item_name]['name'] : '';
                    break;
                default: $s = '';
                }
                
                if ($s !== '') {
                    $t[] = $s;
                }
            }
            if ($t) $content .= '<p><strong>На земле</strong><br />' . implode(', ', $t) . '<p>';
        }
        
        # показываем список доступного оружия
        $content .= '<p><strong>Доступное оружие</strong><br />' . $user->gun['name']
                 . (empty($user->gun['noranged']) # если оружие не ближнего боя, показываем количество патронов
                    ? ' ('.(empty($user->bullets[$user->gun['bullet']]['cur']) ? '0' : $user->bullets[$user->gun['bullet']]['cur']).'/'.(empty($user->bullets[$user->gun['bullet']]['max']) ? '0' : $user->bullets[$user->gun['bullet']]['max']).')'
                    : '');
        foreach ($user->guns as $k => $v) {
            $content .= ' | <a href="?gun='.$k.'">' . $v['name']
                     . (empty($v['noranged']) # если оружие не ближнего боя, показываем количество патронов
                        ? ' ('.(empty($user->bullets[$v['bullet']]['cur']) ? '0' : $user->bullets[$v['bullet']]['cur']).'/'.(empty($user->bullets[$v['bullet']]['max']) ? '0' : $user->bullets[$v['bullet']]['max']).')'
                        : '')
                     . '</a>';
        }
        $content .= '</p>';
        
        # только теперь запуск действий npc
        # пока-что упрощённая модель: только текущая + смежные локации
        /*
        npc_ai($x, $y);
        npc_ai($x, $y - 1); # с
        npc_ai($x + 1, $y); # в
        npc_ai($x, $y + 1); # ю
        npc_ai($x - 1, $y); # з
        /*/
        npc_ai_ext();/**/
        
        # если npc убил перса, то журнал обнулять не нужно
        if ($user->health > 0) {
            $journal = $user->get_journal();
        }
    }
    
    fseek($fileg, 0);
    ftruncate($fileg, 0);
    fwrite($fileg, serialize($map));
    flock($fileg, LOCK_UN);
    fflush($fileg);
    fclose($fileg);
    
    if ( ! isset($user_dead)) {
        if ($user->health <= 0) {
            header('Location: ?' . rand());
            exit;
        } else {
            $top .= '<p>Жизнь: '.$user->health.'%<br />Броня: '.$user->vest.'%</p><hr />';
            $top .= '<a href="?'.rand().'">[обновить]</a><br />';
            
            if ($user->login == 'admin') {
                $top .= '<a href="?exit=1&amp;'.rand().'">[выход]</a><br />';
            }
            
            $content = $top . (empty($journal) ? '' : '<p><strong>Журнал</strong><br />'.$journal.'</p>') . $content;
        }
    }
} else {
    unset($_SESSION[SESNAME]['map']);
    unset($_SESSION[SESNAME]['file']);
    $content = get_content('nomap');
}

# если юзера не существует, значит, вышел
if (empty($map['players'][$user->login])) {
    header('Location: index.php?' . SESNAME . '=' . SESID . '&' . rand());
    exit;
}

header('Content-type:text/html;charset=utf-8');
require_once DIR . DS . 'tpl' . DS . 'index.html';


/*
ob_start();
echo '<pre>';
#print_r($user);
#echo '<hr />';
#print_r($map);
print_r($map[$x][$y]['c']);
#print_r($moves);
echo '</pre>';
$content .= ob_get_contents();
ob_end_clean;/**/

function add_all_journal($loc, $mes) {
    global $map;
    list($x, $y) = $loc;
    if (isset($map[$x][$y]['p'])) foreach ($map[$x][$y]['p'] as $name => $t) {
        if (isset($map['players'][$name])) {
            $map['players'][$name]->add_journal($mes);
        }
    }
}

/**
* проверка дверей
*/
function check_doors($x, $y) {
    global $map;
    
    # дверь на севере
    $door_coord = (string) ($y - 0.5);
    if (isset($map['doors'][$x][$door_coord])) {
        $door =& $map['doors'][$door_coord][$door_coord];
        if ($door['open'] && ($door['ret'] + $door['time']) < ITIME) {
            $door['open'] = 0;
            add_all_journal(array($x, $y), $door['name'] . ', автозакрытие [с]');
            add_all_journal(array($x, $y - 1), $door['name'] . ', автозакрытие [ю]');
        }
        unset($door);
    }
    
    # дверь на востоке
    $door_coord = (string) ($x + 0.5);
    if (isset($map['doors'][$door_coord][$y])) {
        $door =& $map['doors'][$door_coord][$y];
        if ($door['open'] && ($door['ret'] + $door['time']) < ITIME) {
            $door['open'] = 0;
            add_all_journal(array($x, $y), $door['name'] . ', автозакрытие [в]');
            add_all_journal(array($x + 1, $y), $door['name'] . ', автозакрытие [з]');
        }
        unset($door);
    }
    
    # дверь на юге
    $door_coord = (string) ($y + 0.5);
    if (isset($map['doors'][$x][$door_coord])) {
        $door =& $map['doors'][$x][$door_coord];
        if ($door['opren'] && ($door['ret'] + $door['time']) < ITIME) {
            $door['open'] = 0;
            add_all_journal(array($x, $y), $door['name'] . ', автозакрытие [ю]');
            add_all_journal(array($x, $y + 1), $door['name'] . ', автозакрытие [с]');
        }
        unset($door);
    }
    
    # дверь на западе
    $door_coord = (string) ($x - 0.5);
    if (isset($map['doors'][$door_coord][$y])) {
        $door =& $map['doors'][$door_coord][$y];
        if ($door['open'] && ($door['ret'] + $door['time']) < ITIME) {
            $door['open'] = 0;
            add_all_journal(array($x, $y), $door['name'] . ', автозакрытие [з]');
            add_all_journal(array($x - 1, $y), $door['name'] . ', автозакрытие [в]');
        }
        unset($door);
    }
}

/**
* проверка экшнов
*/
function check_action($x, $y) {
    global $map;
    
    if (isset($map['actions'][$x][$y])) {
        $action =& $map['actions'][$x][$y];
        # положение отлично от умолчательного И неоднократный триггер И
        # значение автозакрытия не ноль И пришло время закрытия
        if ($action[2] != $action[3] && ! $action[4] &&
           ! empty($action[7]) && ($action[7] + $action[8]) < ITIME) {
            $action[3] = $action[2];
            $code = $action[5 + empty($action[3])];
            if ( ! empty($code)) eval($code);
            add_all_journal(array($x, $y), $action[0] . ', автоактивация');
            add_all_journal(array($x - 1, $y), $action[0] . ', автоактивация [в]');
            add_all_journal(array($x + 1, $y), $action[0] . ', автоактивация [з]');
            add_all_journal(array($x, $y - 1), $action[0] . ', автоактивация [ю]');
            add_all_journal(array($x, $y + 1), $action[0] . ', автоактивация [с]');
        }
        unset($action);
    }
}

/**
* изменяет информацию о положении перса с $old_loc на $user->loc
*/
function change_loc($old_loc) {
global $user, $map;
    # если пользователь переместился, добавим его в новую локацию, а из
    # старой удалим
    if ($user->loc != $old_loc) {
        unset($map[$old_loc[0]][$old_loc[1]]['p'][$user->login]);
        $map[$user->loc[0]][$user->loc[1]]['p'][$user->login] = 1;
    }
}

/**
* возвращает список противников в локации
*
* @param int $x координата x локации
* @param int $y координата y локации
* @param int $add добавляется только для соседних локаций ([с],[в],[ю],[з])
*/
function get_users($x, $y, $add = '') {
global $map, $user;
    $s = '';
    $loc = $map[$x][$y];
    # смотрим наличие противников
    foreach ($loc['p'] as $k => $v) {
        if ($k == $user->login) continue;
        if (empty($user->gun['noranged']) || empty($add)) {
            $s .= '→<a href="?attack='.$k.'">' . $map['players'][$k]->name . $add . '</a><br />';
        } else $s .= $map['players'][$k]->name . $add . '<br />';;
    }
    return $s;
}

/**
* возвращает список противников в локации
*
* @param int $x координата x локации
* @param int $y координата y локации
* @param int $add добавляется только для соседних локаций ([с],[в],[ю],[з])
*/
function get_npc($x, $y, $add = '') {
global $map, $user, $npc;
    $s = '';
    # смотрим наличие противников
    foreach ($map[$x][$y]['n'] as $k => $v) {
        $name = $map['npc'][$k]['npc']['name'];
        $health = '('.$map['npc'][$k]['npc']['health'].')';
        if (empty($user->gun['noranged']) || empty($add)) {
            $s .= '<a href="?attack='.$k.'&amp;n">' . $name . $health . $add . '</a><br />';
        } else $s .= $name . $health . $add . '<br />';;
    }
    return $s;
}

/**
* Просчёт атаки на пользователей
*/
function user_attack($auser) {
global $user, $map;
    
    $st = $user->get_damage();
    list($x, $y) = $auser->loc;
    
    if (is_array($st)) {
        # определяем урон
        $losses = rand($st['damage'][0], $st['damage'][1]);
        if ($losses > 0) {
            $auser->damage($losses);
            $death = empty($auser->health);
            $auser->add_journal($user->name . ' нанёс Вам урон ' . $losses . ($death ? '. Вы умерли' : ''));
            $user->add_journal('Вы нанесли '.$losses.' урона ' . $auser->name . ($death ? ', что привело к его смерти' : ''));
            if ($death) { # если атакуемый умер, обновим статистику
                ++$auser->die;
                ++$user->frag;
                unset($map[$x][$y]['p'][$auser->login]);
                
                # формируем труп
                $map[$x][$y]['c'][] = array(
                    'id'    => $map['frags']++,
                    'type'  => 0,
                    'name'  => $auser->name,
                    'time'  => ITIME,
                    'trophy'=> get_trophy($auser),
                    'login' => $auser->login,
                    'items' => $auser->create_items()
                );
            }
/* хохмы:
    , что доставило ему радость в виде встречи с прадедушкой
    , что привело его к скоропостижной смерти
*/
        }
        
        if (empty($damage['add_damage'])) return TRUE;
        
    } else {
        switch ($st) {
        case 1: $user->add_journal('Кончились патроны');
            break;
        case 2: $user->add_journal('Оружие ещё не перезарядилось');
            break;
        default: $user->add_journal('Нельзя атаковать');
        }
        return FALSE;
    }
    
    return TRUE;
}

/**
* Просчёт атаки на npc
*/
function npc_attack($npc_at) {
global $user, $map;
    $anpc = $map['npc'][$npc_at];
    $st   = $user->get_damage();
    list($x, $y) = $anpc['loc'];
    
    if (is_array($st)) {
        # определяем урон
        $losses = rand($st['damage'][0], $st['damage'][1]);
        if ($losses > 0) {
            $map['npc'][$npc_at]['npc']['health'] -= $losses;
            if ($map['npc'][$npc_at]['npc']['health'] < 1) {
                $map['npc'][$npc_at]['npc']['health'] = 0;
            }
            $death = empty($map['npc'][$npc_at]['npc']['health']);
            $user->add_journal('Вы нанёсли '.$losses.' урона ' . $anpc['npc']['name'] . ($death ? ', что привело к его смерти' : ''));
            if ($death) { # если атакуемый умер, обновим статистику
                ++$user->kill;
                $map['npc'][$npc_at]['rtime'] = ATIME + $map['npc'][$npc_at]['resurrection'];
                unset($map[$x][$y]['n'][$npc_at]);
                $map['npc'][$map['monsters']++] = $map['npc'][$npc_at];
                unset($map['npc'][$npc_at]);
                
                # формируем труп
                $map[$x][$y]['c'][] = array(
                    'id'    => $map['frags']++,
                    'type'  => 1,
                    'name'  => $anpc['npc']['name'],
                    'time'  => ITIME,
                    'trophy'=> 0,
                    'login' => $npc_at,
                    'items' => isset($anpc['npc']['items']) ? $anpc['npc']['items'] : array(),
                );
            }
        }
        
        if (empty($damage['add_damage'])) return TRUE;
        
    } else {
        switch ($st) {
        case 1: $user->add_journal('Кончились патроны');
            break;
        case 2: $user->add_journal('Оружие ещё не перезарядилось');
            break;
        default: $user->add_journal('Нельзя атаковать');
        }
        return FALSE;
    }
    
    return TRUE;
}

/**
* возвращает случайный трофей (пока только шеврон)
*/
function get_trophy($user) {
    return 'chevron'; # шеврон
}

/**
* карта перемещения для указанной локации
*/
function create_map_moves($x, $y) {
global $map;
    if (empty($map[$x][$y])) return array(0,0,0,0);
    
    $doors  = create_map_doors($x, $y);
    $moves  = array(0, 0, 0, 0);
    $loc    = $map[$x][$y];
    $z      = empty($loc['z']) ? 0 : $loc['z'];
    $nz     = empty($map[$x][$y - 1]['z']) ? 0 : $map[$x][$y - 1]['z'];
    $ne     = empty($map[$x + 1][$y]['z']) ? 0 : $map[$x + 1][$y]['z'];
    $ns     = empty($map[$x][$y + 1]['z']) ? 0 : $map[$x][$y + 1]['z'];
    $nw     = empty($map[$x - 1][$y]['z']) ? 0 : $map[$x - 1][$y]['z'];
    
    if ($loc['w'][0] && $z >= $nz && (empty($doors[0]) || $doors[0]['open'])) $moves[0] = 1;
    if ($loc['w'][1] && $z >= $ne && (empty($doors[1]) || $doors[1]['open'])) $moves[1] = 1;
    if ($loc['w'][2] && $z >= $ns && (empty($doors[2]) || $doors[2]['open'])) $moves[2] = 1;
    if ($loc['w'][3] && $z >= $nw && (empty($doors[3]) || $doors[3]['open'])) $moves[3] = 1;
    
    return $moves;
}

function create_map_doors($x, $y) {
global $map;
    if (empty($map[$x][$y])) return array();
    
    $doors = array();
    # север
    $door_coord = (string) ($y - 0.5);
    if (isset($map['doors'][$x][$door_coord])) {
        $doors[0] = $map['doors'][$x][$door_coord];
    }
    # восток
    $door_coord = (string) ($x + 0.5);
    if (isset($map['doors'][$door_coord][$y])) {
        $doors[1] = $map['doors'][$door_coord][$y];
    }
    # юг
    $door_coord = (string) ($y + 0.5);
    if (isset($map['doors'][$x][$door_coord])) {
        $doors[2] = $map['doors'][$x][$door_coord];
    }
    # запад
    $door_coord = (string) ($x - 0.5);
    if (isset($map['doors'][$door_coord][$y])) {
        $doors[3] = $map['doors'][$door_coord][$y];
    }
    return $doors;
}

/**
* просчёт действий npc происходит всегда (а не только когда рядом игрок)
*/
function npc_ai_ext() {
global $map;
    $npc = $map['npc'];
    
    foreach ($npc as $k => $v) {
        # может ли npc атаковать
        if ($v['time'] + $v['npc']['delay'] > ATIME || $v['rtime']) continue;
        $map['npc'][$k]['time'] = ATIME; # установка нового времени
        list($x, $y) = $v['loc'];
        
        switch ($v['npc']['ai']) {
        case 1: # 1 к 2, что не будет атаковать
            if (rand(1,3) == 1) { # атаковать
                $attack = npc_ai_choose($x, $y, $k);
                if ($attack) npc_ai_attack($k, $attack);
                else npc_ai_move($x, $y, $k);
            } else { # двигаться
                npc_ai_move($x, $y, $k);
            }
            break;
        case 2: # 1 к 2, что будет атаковать
            if (rand(1,3) == 1) { # двигаться
                npc_ai_move($x, $y, $k);
            } else { # атаковать
                $attack = npc_ai_choose($x, $y, $k);
                if ($attack) npc_ai_attack($k, $attack);
                else npc_ai_move($x, $y, $k);
            }
            break;
        case 3: # если рядом кто-то есть, всегда атакует
            $attack = npc_ai_choose($x, $y, $k);
            if ($attack) npc_ai_attack($k, $attack);
            else npc_ai_move($x, $y, $k);
            break;
        default: # по умолчанию принимаем простейшую модель поведения: стой-стреляй
            $attack = npc_ai_choose($x, $y, $k);
            if ($attack) npc_ai_attack($k, $attack);
        }
    }
}

/**
* действия npc
*/
function npc_ai($x, $y) {
global $map;
    if (empty($map[$x][$y])) return;
    
    foreach ($map[$x][$y]['n'] as $k => $v) {
        # если атаковать ещё не может, на выход
        if ($map['npc'][$k]['time'] + $map['npc'][$k]['npc']['delay'] > ATIME) continue;
        $map['npc'][$k]['time'] = ATIME; # установка нового времени
        switch ($map['npc'][$k]['npc']['ai']) {
        case 1:
            if (rand(1,3) == 1) { # атаковать
                $attack = npc_ai_choose($x, $y, $k);
                if ($attack) npc_ai_attack($k, $attack);
            } else { # двигаться
                npc_ai_move($x, $y, $k);
            }
            break;
        case 2: 
            if (rand(1,3) == 1) { # двигаться
                npc_ai_move($x, $y, $k);
            } else { # атаковать
                $attack = npc_ai_choose($x, $y, $k);
                if ($attack) npc_ai_attack($k, $attack);
            }
            break;
        case 3: 
            break;
        default: # по умолчанию принимаем простейшую модель поведения: стой-стреляй
            $attack = npc_ai_choose($x, $y, $k);
            if ($attack) npc_ai_attack($k, $attack);
        }
    }
}

/**
* случайным образом выбор атакуемого игрока
*/
function npc_ai_choose($x, $y, $cnpc) {
global $map, $user;
    $loc    = $map[$x][$y];
    $attack = array('');
    $ch     = array(0,1,2,3);
    shuffle($ch);
    
    # построим карту видимости
    $moves = create_map_moves($x, $y);
    
    # нужен случайный выбор атаки: сюзв
    $mx     = array(0, 1, 0,-1);
    $my     = array(-1,0, 1, 0);
    
    # атакуется игрок в текущей локации, если никого нет, смотреть соседние
    if ($loc['p']) {
        $attack = array_keys($loc['p']);
    } elseif (empty($map['npc'][$cnpc]['npc']['noranged'])) {
        # если npc атакует только вблизи, атаковать некого
        if ($moves[$ch[0]] && $map[$x+$mx[$ch[0]]][$y+$my[$ch[0]]]['p']) {
            $attack = array_keys($map[$x+$mx[$ch[0]]][$y+$my[$ch[0]]]['p']);
        } elseif ($moves[$ch[1]] && $map[$x+$mx[$ch[1]]][$y+$my[$ch[1]]]['p']) {
            $attack = array_keys($map[$x+$mx[$ch[1]]][$y+$my[$ch[1]]]['p']);
        } elseif ($moves[$ch[2]] && $map[$x+$mx[$ch[2]]][$y+$my[$ch[2]]]['p']) {
            $attack = array_keys($map[$x+$mx[$ch[2]]][$y+$my[$ch[2]]]['p']);
        } elseif ($moves[$ch[3]] && $map[$x+$mx[$ch[3]]][$y+$my[$ch[3]]]['p']) {
            $attack = array_keys($map[$x+$mx[$ch[3]]][$y+$my[$ch[3]]]['p']);
        }
    }
    return $attack ? $attack[rand(0, count($attack) - 1)] : '';
}

/**
* атака персов
*/
function npc_ai_attack($cnpc, $cuser) {
global $map, $user;
    $auser = $map['players'][$cuser];
    $anpc  = $map['npc'][$cnpc];
    list($x, $y) = $auser->loc;
    
    # определяем урон
    $losses = rand($anpc['npc']['damage'][0], $anpc['npc']['damage'][1]);
    if ($losses > 0) {
        $auser->damage($losses);
        $death = empty($auser->health);
        $auser->add_journal($anpc['npc']['name'] . ' нанёс Вам урон ' . $losses . ($death ? '. Вы умерли' : ''));
        if ($death) { # если атакуемый умер, обновим статистику
            ++$user->kill;
            unset($map[$x][$y]['p'][$auser->login]);
            
            # формируем труп
            $map[$x][$y]['c'][] = array(
                'id'    => $map['frags']++,
                'type'  => 0,
                'name'  => htmlspecialchars($auser->name),
                'time'  => ITIME,
                'trophy'=> get_trophy($auser),
                'login' => $auser->login,
                'items' => isset($anpc['npc']['items']) ? $anpc['npc']['items'] : array(),
            );
        }
    }
    
    return TRUE;
}

/**
* движение npc
*/
function npc_ai_move($x, $y, $cnpc) {
global $map;
    $moves = create_map_moves($x, $y);
    # определим, куда бы переместиться
    $ch = array(0,1,2,3);
    shuffle($ch);
    
    for ($i = 0; $i < 4; $i++) {
        if ($moves[$ch[$i]]) {
            $side = $ch[$i];
            break;
        }
    }
    if (isset($side)) {
        $mx     = array(0, 1, 0,-1);
        $my     = array(-1,0, 1, 0);
        $newx   = $x + $mx[$side];
        $newy   = $y + $my[$side];
        
        unset($map[$x][$y]['n'][$cnpc]);
        $map[$newx][$newy]['n'][$cnpc] = 1;
        $map['npc'][$cnpc]['loc'] = array($newx, $newy);
    } return TRUE;
    
    return FALSE;
}

echo '<!-- '.round(microtime(1) - ATIME, 4).' -->';