<?php
define('ATIME',     microtime(1));          # время запуска скрипта
define('ITIME',     (int) ATIME);           # время запуска скрипта
define('DS',        DIRECTORY_SEPARATOR);   # разделитель пути
define('DIR',       dirname(__FILE__) . DS);# текущий директорий
define('SRC',       DIR . '#main' . DS);    # файлы игры
define('MAPS',      DIR . '#maps' . DS);    # карты
define('USERS',     DIR . '#save' . DS);    # сохранёнки юзеров
define('GAME',      DIR . '#game' . DS);    # сохранёнки
define('SESNAME',   'doom');                # имя сессии

# особые установки
define('ACTIME', 1);                        # перерыв между действиями пользователя (чтобы не было явного преимущества у человека, сидящего на выделенке)

$cfg = array(
    'user_active'           => 15 * 60,     # через сколько пользователя считать неактивным
    'corp'                  => 5 * 60,      # через сколько труп исчезнет
    'forum_theme'           => 10,          # количество показываемых тем
    'forum_message'         => 10,          # количество показываемых сообщений
);

$params = array();

set_error_handler('andb_error_handler');
ini_set('display_errors', 0);
ini_set('error_reporting', 65535);
date_default_timezone_set('Europe/Moscow');

session_name(SESNAME);
session_start();
define('SESID', session_id());

$content = '';
$title   = '';

if (file_exists(DIR . 'classes.php')) require_once DIR . 'classes.php';
else {
    require_once SRC . 'guns.php';
    require_once SRC . 'bullets.php';
    require_once SRC . 'items.php';
    require_once SRC . 'trophy.php';
    require_once SRC . 'user.php';
    require_once SRC . 'npc.php';
}

function get_content($file = 'main', $params = array()) {
    $get_content_tpl = DIR . DS . 'tpl' . DS . $file . '.html';
    ob_start();
    foreach ($params as $k => $v) $$k = $v;
    include $get_content_tpl;
    $get_content_buf = ob_get_contents();
    ob_end_clean();
    return $get_content_buf;
}




    
/**
* Глобальный обработчик ошибок
*
* @param int $errno номер ошибки
* @param string $msg расшифровка ошибки
* @param string $file файл, в котором возникла ошибка
* @param int $line строка, в которой возникла ошибка
* @return bool=TRUE
*/
function andb_error_handler($errno, $msg, $file, $line) {
    // на выход, если была операция с использованием @
    if (error_reporting() == 0) return TRUE;
    
    $dtz = date_default_timezone_get();
    // все ошибки пишутся по гринвичевскому времени
    date_default_timezone_set('GMT');
    $t = explode('.', date('Y-m-d.H:i:s', ITIME));
    date_default_timezone_set($dtz);
    
    switch ($errno) {
    case E_ERROR: $error_msg = 'Error';
        break;
    case E_WARNING: $error_msg = 'Warning';
        break;
    case E_PARSE: $error_msg = 'Parsing Error';
        break;
    case E_NOTICE: $error_msg = 'Notice';
        break;
    case E_CORE_ERROR: $error_msg = 'Core Error';
        break;
    case E_CORE_WARNING: $error_msg = 'Core Warning';
        break;
    case E_COMPILE_ERROR: $error_msg = 'Compile Error';
        break;
    case E_COMPILE_WARNING: $error_msg = 'Compile Warning';
        break;
    case E_USER_ERROR: $error_msg = 'User Error';
        break;
    case E_USER_WARNING: $error_msg = 'User Warning';
        break;
    case E_USER_NOTICE: $error_msg = 'User Notice';
        break;
    case E_STRICT: $error_msg = 'Runtime Notice'; // нерекомендуемые конструкции
        break;
    case E_RECOVERABLE_ERROR: $error_msg = 'Catchable Fatal Error';
        break;
    default: $error_msg = 'Unknown error';
    }
    
    $s = $t[1].': Error '.$error_msg.' ('.trim($msg).') in file "'.$file
       . '" ['.$line."]\n";
    # куда записывать ошибки
    #file_put_contents(DIR . '#errors' . DS . $t[0], $s, FILE_APPEND);
    return TRUE;
}
